package org.flixel.plugin.FlxSWFStates
{
	import com.greensock.events.LoaderEvent;
	import com.greensock.loading.LoaderMax;
	import com.greensock.loading.SWFLoader;
	import com.greensock.loading.core.LoaderCore;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.system.ApplicationDomain;
	import flash.system.LoaderContext;
	import flash.system.SecurityDomain;
	
	import org.flixel.FlxState;
	
	public class DynamicSWFStatePopulator extends SWFStatePopulator
	{
		public function DynamicSWFStatePopulator( stateToPopulate:FlxState, swfFilePath:String = "test.swf", onPopulatedCallback:Function=null )
		{
			super( stateToPopulate, onPopulatedCallback );
			
			var theContext:LoaderContext = new LoaderContext( false, ApplicationDomain.currentDomain.parentDomain );
			
			LoaderMax.defaultContext = theContext;
			var loader:LoaderMax = new LoaderMax( { context: theContext } );
			loader.autoLoad = true;
			
			loader.append( new SWFLoader( swfFilePath, { context: theContext } ) );
			
			loader.addEventListener( Event.COMPLETE, levelSWFLoaded, false, 0, true );
			
		}
		
		protected function levelSWFLoaded( event:LoaderEvent ):void
		{
			var theLoader:LoaderMax = LoaderMax( event.target );
			
			for each( var loader:LoaderCore in theLoader.getChildren( false, true ) )
			{
				var swfLoader:SWFLoader = loader as SWFLoader;
				
				if( swfLoader == null )
				{
					// No non-SWF loaders should exist, but if they somehow do we'll just skip them.
					continue;
				}
				
				var rawStage:Sprite = swfLoader.rawContent as Sprite;
				
				if( rawStage == null )
				{
					throw Error("Couldn't find stage for SWF!");
				}
				
				processStageInstance( rawStage );
				
				break;	// Yeah we just pretended to be a loop. Let's just process one of these.
			}
		}
		
	}
}