package org.flixel.plugin.FlxSWFStates
{
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	
	import org.flixel.FlxState;
	
	public class EmbeddedSWFStatePopulator extends SWFStatePopulator
	{
		
		private var levelSWFInstance:Sprite;

		private var _levelSWFClass:Class;
		
		public function EmbeddedSWFStatePopulator( stateToPopulate:FlxState, levelSWFClass:Class, onPopulatedCallback:Function = null )
		{
			super( stateToPopulate, onPopulatedCallback );
			
			_levelSWFClass = levelSWFClass;
			
			levelSWFInstance = new _levelSWFClass() as Sprite;
			
			levelSWFInstance.addEventListener( Event.COMPLETE, levelSWFLoaded );
			
			
		}
		
		protected function levelSWFLoaded(event:Event):void
		{
			var loader:Loader = levelSWFInstance.getChildAt(0) as Loader;
			
			var mapStage:Sprite = (loader.content as Sprite);
			
			processStageInstance( mapStage );
			
			
		}
		
		
	}
}