package
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	
	import org.flixel.FlxObject;
	import org.flixel.FlxState;
	import org.flixel.plugin.FlxSWFStates.DynamicSWFStatePopulator;
	
	public class BaseSWFLevel extends BaseLevel
	{
		protected var populator:DynamicSWFStatePopulator;
		
		public function BaseSWFLevel()
		{
			super();
		}
		
		public override function create():void
		{
			populator = new DynamicSWFStatePopulator( this, getSWFFilePath(), onSWFStatePopulationComplete );
			
			super.create();
			
		}
		
		protected function onSWFStatePopulationComplete( newStage:Sprite ):void
		{
			// TODO: Hook in here for the event once level population is completed.
		}
		
		protected function getSWFFilePath():String
		{
			throw Error("Pure virtual");
			return null;
		}
		
		
		public function addObjectFromSWFProxy( object:FlxObject, originalDisplayObject:DisplayObject ):void
		{
			if( object is Planet )
			{	
				planets.push( object );
				planetsGrp.add( object );
			}
			else if( object is Sun )
			{
				sun = object as Sun;
				add( sun );
			}
			else
			{
				add( object );
			}
		}
		
	}
}